//Obsluha TWI
//Subor 		twi.cpp

#include "twi.h"
#define F_CPU 8000000UL


//Inicializacia a nastavenie rychlosti prenosu
void twiInit(uint32_t speed)
{
	//Spust TWI
	TWCR = (1<<TWEA) | (1<<TWEN);

	//Nastav rychlost prenosu
	uint8_t prescaler = 0;
	speed = (F_CPU/speed/100-16)/2;

	while(speed > 255)
	{
		prescaler++;
		speed=speed/4;
	}

	TWSR = (TWSR & ((1<<TWPS1) | (1<<TWPS0))) | prescaler;
	TWBR = speed;
}

//Start
void twiStart()
{
	TWCR = (1<<TWINT)|(1<<TWSTA)| (1<<TWEN);	//odosli
	while (!(TWCR & (1<<TWINT)));	//cakaj
}

//Stop
void twiStop()
{
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);	//odosli
	while(TWCR & (1<<TWSTO));	//cakaj
}

//Odosli adresu
void twiAddress(uint8_t data)
{
	TWDR = data;	//odosli
	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));	//cakaj
}

//Odosli data
void twiWrite(uint8_t data)
{
	TWDR = data;	//odosli
	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));	//cakaj
}

//Nacitaj data
uint8_t twiReadACK()
{
	TWCR = (1<<TWEA) | (1<<TWINT) | (1<<TWEN);	//nacitaj
	while (!(TWCR & (1<<TWINT)));	//cakaj

	return TWDR; //vysledok
}

//Nacitaj NACK
uint8_t twiReadNACK()
{
	TWCR = (1<<TWINT) | (1<<TWEN);	//nacitaj
	while (!(TWCR & (1<<TWINT)));	//cakaj

	return TWDR;	//vysledok
}
